#include "config.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef OS_LINUX
	#include <unistd.h>
	#include <netdb.h>
	#include <sys/types.h>
	#include <netinet/in.h>
	#include <sys/socket.h>
#endif

#ifdef OS_WINDOWS
	#include <winsock.h>
#endif

#include "connection.h"
#include "ycht_pkt.h"

#define CHATPORT				8002
#define CHATSERVER			"cs8.chat.snv.yahoo.com"

#define PROFILESERVER	"msg.edit.yahoo.com"
#define PROFILEPORT			80

/* returns the socket on success, 0 on failiure */
int Connect(char *servername, int port)
{
	int S, ret;
	struct hostent *he_server;
	struct sockaddr_in svr_addr;

	/* try to resolve the server hostname */
	if((he_server=gethostbyname(servername)) == NULL)
	{
		fprintf(stderr,"Error translating name\n");
		return -1;
	}
	
	/* create the socket */
	S = socket(AF_INET,SOCK_STREAM,0);
	if(S < 0)
	{
		fprintf(stderr,"Error creating socket\n");
		return -1;
	}

	/* server's address information */
	svr_addr.sin_family = AF_INET;
	svr_addr.sin_port = htons(port);
	svr_addr.sin_addr = *( (struct in_addr *) he_server->h_addr);
	memset(&(svr_addr.sin_zero),'\0',8);

	/* conect to the server socket */
	ret=connect(S,(struct sockaddr *)&svr_addr,sizeof(struct sockaddr_in));
	if(ret==-1)
	{
		fprintf(stderr,"Error connecting to server!\n");
		return -1;
	}
	else
		return S;
}

int GetCookie(char * cookie, char *usrname,char *pwd)
{
	const int rbuf_len=1048;
	char http_request[160],http_answer[rbuf_len];
	char *stridx;
	int S,nbytes,len,len2;

	/* ASSEMBLE THE HTTP REQUEST */

	/* TODO find out why Im only getting headers! */
	strcpy(http_request,"GET /config/ncclogin?.src=bl&login=");
	strcat(http_request,usrname);
	strcat(http_request,"&passwd=");
	strcat(http_request,pwd);
	strcat(http_request,"&n=1");
	strcat(http_request," HTTP/1.0\n\n");

	if((S=Connect(PROFILESERVER,PROFILEPORT))==-1)
		return -1;

	send(S,http_request,strlen(http_request),0);

	/* receive the request */
	nbytes=recv(S,http_answer,rbuf_len,0);
	stridx=strstr(http_answer,"Y=v=");
	len=strcspn(stridx," ")+1;
	strncpy(cookie,stridx,len);
	stridx=strstr(http_answer,"T=z=");
	len2=strcspn(stridx,";");
	strncpy(cookie+len,stridx,len2);
	*(cookie+len+len2)='\0';

	Disconnect(S);
	return 0;
}

int Disconnect(int socket)
{
	#ifdef OS_LINUX
		close(socket);
	#endif
	#ifdef OS_WINDOWS
		closesocket(socket);
	#endif
	return 0;
}

int GetPacket(int S,char * rbuf)
{
	fd_set fdread;
	int dataleft,got_header;

	got_header=0;
	dataleft=0;     /* just to make gcc happy */
	for(;;)
	{
		FD_ZERO(&fdread);
		FD_SET(S,&fdread);
		select(S+1,&fdread,NULL,NULL,NULL);

		if(!got_header)
		{
			recv(S,rbuf,HDR_LEN,0);
			dataleft=pktGetLen(rbuf);
			got_header=1;
		}
		else
		{
			dataleft-=recv(S,rbuf+HDR_LEN,dataleft,0);
			if(dataleft==0) break;
		}
	}

	return 0;
}
