
/* this might be against Google's Terms of Service, so I leave it here incomplete */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <regex.h>
#include <sys/types.h>
#include <errno.h>
#include <http_fetcher.h>
#include <libhtmlparse.h>
#include <glib.h>

#include "constants.h"
#include "google.h"

#define GOOGLE_URL "http://www.google.com/search?q="
#define KEYWORD_REGEX "[[:alnum:]]+"
#define MAX_KEYWORDS 4

#define MAX_SUB 1

static GString *
google_prepare_query(const GString *nasty)
{
  regex_t pattern;
  regmatch_t matches[MAX_SUB];
  int ret;
  GString *result;
  char *ptr;
  
  ret = regcomp(&pattern, KEYWORD_REGEX, REG_ICASE | REG_EXTENDED);
  if (ret != 0)
    goto error_regcomp;
  result = g_string_new("");
  ptr = nasty->str;
  while ((ret = regexec(&pattern, ptr, MAX_SUB, matches, 0)) == 0)
	 {
		g_string_append_len(result, ptr + matches[0].rm_so, 
								  matches[0].rm_eo - matches[0].rm_so);
		g_string_append_c(result, '+');
		ptr += matches[0].rm_eo;
	 }
  if (result->len > 0)
	 g_string_truncate(result, result->len - 1);
  regfree(&pattern);
  return result;

 error_regcomp:
  return NULL;
}

static GString *
google_search(GString *prepared_search)
{
  char *response;
  int res;
  GString *url, *result;
  
  url = g_string_new("");
  g_string_printf(url, "%s%s", GOOGLE_URL, prepared_search->str);
  http_setUserAgent(HTTP_USERAGENT);
  http_setTimeout(HTTP_TIMEOUT);
  res = http_fetch(url->str, &response);
  if (res == -1)
    {
      http_perror("google");
      goto error_fetch;
    }
  result = g_string_new(response);
  free(response);
  return result;

 error_fetch:
  g_string_free(url, TRUE);
  return NULL;
}


static GString *google_result;

static int 
google_tag_start(char *tag, struct ArgvTable *args, int numargs)
{
  int i;

  return 0;
}

static GString *
google_parse_response(GString *response)
{
  int (*oldStartCallBack) (char *, struct ArgvTable *, int);
  int (*oldCommentCallBack) (char *);

  oldStartCallBack = startCallBack;
  startCallBack = google_tag_start;
  google_result = g_string_new("");
  parse(response->str);
  startCallBack = oldStartCallBack;
  
  return google_result;
}


GString *
google(GString *nasty)
{
  GString *clean, *response, *result;

  clean = google_prepare_query(nasty);
  if (clean == NULL)
	 goto error_query;
  response = google_search(clean);
  if (response == NULL)
	 goto error_search;
  result = google_parse_response(response);
  if (result == NULL)
	 goto error_result;

  g_string_free(clean, TRUE);
  g_string_free(response, TRUE);
  return result;

 error_result:
  g_string_free(response, TRUE);
 error_search:
  g_string_free(clean, TRUE);
 error_query:
  return NULL;
}


/* Local Variables: */
/* tab-width: 3 */
/* End: */
