
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#include "helpers.h"

int file2str(char * str, const char * filename)
{
	FILE *fp;
	char ch;
	int x;

	if((fp=fopen(filename,"r"))==NULL) return -1;

	for(x=0;(ch=getc(fp))!=EOF;x++)
		str[x]=ch;

	str[x]='\0';
	fclose(fp);
	return 0;
}

void strip_tags(char * str, const char *opentag, const char *closetag)
{
	int first,last;
	/* search for tags and dont finish till all are found */
	for(;;)
	{
		first=strcspn(str,opentag);
		last=strcspn(str,closetag);
		if(first >= strlen(str) || last < first)
			break;
		else
			strcpy((str+first),(str+last+1));
	}
}

void time2str(char * str)
{
	time_t t;
	time(&t);
	sprintf(str,"server time:\n%s",ctime(&t));
}

void uptime2str(char * str, time_t st)
{
	double elapsed;
	int d,h,m,s;

	elapsed=difftime((time_t)time(NULL),st);

	d=(int) elapsed/86400;
	h=(int) (elapsed-(d*86400))/3600;
	m=(int) (elapsed-((d*86400)+(h*3600)))/60;
	s=(int) elapsed-( (d*86400)+(h*3600)+(m*60) );

	sprintf(str,"uptime:\n %d days, %d:%d:%d",d,h,m,s);
}


void
random_sleep(int max)
{
  sleep(rand() % max + 1);
}


/* Local Variables: */
/* tab-width: 3 */
/* End: */
