
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "trustlist.h"
#include "constants.h"

void UserDel(const char *user2del)
{
	FILE *fptemp,*fptl;
	char tl_user[MAX_UNAME_LEN];

	fptemp=fopen(F_TEMP,"w");
	fptl=fopen(F_TRUST_FILE,"r");
	
	/* bugfix: if file doesn't exist, we get a seg fault (je) */
	if(fptl != NULL)
	{
		while(fgets(tl_user,MAX_UNAME_LEN,fptl)!=NULL)
		{
			tl_user[strcspn(tl_user,"\n")]='\0'; /* strip off newline */
			if(!strcmp(user2del,tl_user))
				continue;
			else
			{
				fputs(tl_user,fptemp);
				fputc('\n',fptemp);
			}
		}
	}

	fclose(fptemp);
	fclose(fptl);

	remove(F_TRUST_FILE);
	rename(F_TEMP,F_TRUST_FILE);
}

void UserAdd(const char *user2add)
{
	FILE *fptl;

	fptl=fopen(F_TRUST_FILE,"a");
	
	/* bugfix: if file doesn't exist, we get a seg fault (je) */
	if(fptl != NULL)
	{
		fputs(user2add,fptl);
		fputc('\n',fptl);
	}
	fclose(fptl);
}

int IsTrusted(char *user)
{
	FILE *fptl;
	char tl_user[MAX_UNAME_LEN];

	fptl=fopen(F_TRUST_FILE,"r");

	/* bugfix: if file doesn't exist, we get a seg fault (je) */
	if(fptl != NULL)
	{
		while(fgets(tl_user,MAX_UNAME_LEN,fptl)!=NULL)
		{
			tl_user[strcspn(tl_user,"\n")]='\0'; /* strip off newline */
			if(!strcmp(user,tl_user)) return 1;
		}
	}
	return 0;
}


/* Local Variables: */
/* tab-width: 3 */
/* End: */
